--- ../clean/asterisk-1.4.8/apps/app_directed_pickup.c	2007-06-06 15:16:34.000000000 +0200
+++ apps/app_directed_pickup.c	2007-08-08 16:25:21.000000000 +0200
@@ -42,17 +42,18 @@
 #include "asterisk/lock.h"
 #include "asterisk/app.h"
 #include "asterisk/options.h"
+#include "asterisk/features.h"
 
 #define PICKUPMARK "PICKUPMARK"
 
 static const char *app = "Pickup";
 static const char *synopsis = "Directed Call Pickup";
 static const char *descrip =
-"  Pickup(extension[@context][&extension2@context...]): This application can pickup any ringing channel\n"
+"  Pickup([extension][@context][&extension2@context...]): This application can pickup any ringing channel\n"
 "that is calling the specified extension. If no context is specified, the current\n"
 "context will be used. If you use the special string \"PICKUPMARK\" for the context parameter, for example\n"
 "10@PICKUPMARK, this application tries to find a channel which has defined a channel variable with the same content\n"
-"as \"extension\".";
+"as \"extension\". When no parameter is specified the application will pickup a channel matching the pickup group of the active channel.";
 
 /* Perform actual pickup between two channels */
 static int pickup_do(struct ast_channel *chan, struct ast_channel *target)
@@ -138,12 +139,12 @@
 	char *tmp = ast_strdupa(data);
 	char *exten = NULL, *context = NULL;
 
+	u = ast_module_user_add(chan);
 	if (ast_strlen_zero(data)) {
-		ast_log(LOG_WARNING, "Pickup requires an argument (extension)!\n");
-		return -1;	
+		res=ast_pickup_call(chan);
+		ast_module_user_remove(u);
+		return res;
 	}
-
-	u = ast_module_user_add(chan);
 	
 	/* Parse extension (and context if there) */
 	while (!ast_strlen_zero(tmp) && (exten = strsep(&tmp, "&"))) {
